
#include "key.h"
#include "stdint.h"
#include "led.h"

uint8_t key_up_sta;

/*------------------------ⲿжϳʼ----------------------------*/
void KEY_GPIO_Init()
{
	
	__HAL_RCC_GPIOA_CLK_ENABLE();
	GPIO_InitTypeDef KEY_GPIO_InitStruct;
	
	//PA0ΪKey_Up,Ϊͨģʽ
	KEY_GPIO_InitStruct.Mode	=	GPIO_MODE_INPUT;
	KEY_GPIO_InitStruct.Pin		=	(GPIO_PIN_0);
	KEY_GPIO_InitStruct.Pull	=	GPIO_PULLDOWN;   //ΪӲΪⲿߵƽ,PA0ųʼʱҪΪģʽ
	KEY_GPIO_InitStruct.Speed	=	GPIO_SPEED_FREQ_LOW;
	HAL_GPIO_Init(GPIOA,&KEY_GPIO_InitStruct);
	
}


//		mode: 0--(½)ִ,1--̧()ִ
void KEY_GPIO_Init_IT(uint8_t mode)
{
	__HAL_RCC_GPIOE_CLK_ENABLE();
	GPIO_InitTypeDef KEY_GPIO_InitStruct;
	
	//PE2,PE3ֱKEY_LEFT,KEY_DOWN,Ϊжϴģʽ
	KEY_GPIO_InitStruct.Pin=(GPIO_PIN_2|GPIO_PIN_3);
	if(mode==0)
		KEY_GPIO_InitStruct.Mode=GPIO_MODE_IT_FALLING;
	else
		KEY_GPIO_InitStruct.Mode=GPIO_MODE_IT_RISING;
	KEY_GPIO_InitStruct.Pull=GPIO_PULLUP;   
	HAL_GPIO_Init(GPIOE,&KEY_GPIO_InitStruct);
	
	//stm32f103xe.h69кԲ鿴жϷ,жȼ
	HAL_NVIC_SetPriority(EXTI2_IRQn,4,0);
	HAL_NVIC_SetPriority(EXTI3_IRQn,3,0);

	//ʹָж
	HAL_NVIC_EnableIRQ(EXTI2_IRQn);
	HAL_NVIC_EnableIRQ(EXTI3_IRQn);

}

/*------------------------¼жϳʼ----------------------------*/
void KEY_GPIO_Init_Event(void)
{
	
	__HAL_RCC_GPIOE_CLK_ENABLE();
	GPIO_InitTypeDef KEY_GPIO_InitStruct;
	
	//PE4ΪKYE_RIGHT,Ϊ½¼ģʽ
	KEY_GPIO_InitStruct.Mode	=	GPIO_MODE_EVT_FALLING;
	KEY_GPIO_InitStruct.Pin		=	(GPIO_PIN_4);
	KEY_GPIO_InitStruct.Pull	=	GPIO_PULLUP;  
	HAL_GPIO_Init(GPIOE,&KEY_GPIO_InitStruct);
	
}


/*
		mode: 0--ִ,1--ִ̧
ֵ	      0--û,1--
*/
//ݵ·ԭͼ֪ʱ,͵ƽ
uint8_t KEY_ScanL(uint8_t mode)
{
	uint32_t i;
	/*------------------ִ-------------------*/
	if((KEY_UP==KEY_ON)&&(key_up_sta==0))
	{
		//ֹ󴥷
		for(i=0; i<0x3FFF; i++)
		{
			if(KEY_UP==KEY_OFF)
			{
				return 0;
			}
		}
		key_up_sta=1;
		if(mode==0)
		{
			return 1;
		}
	}
	/*------------------ִ̧-------------------*/	
	else if((KEY_UP==KEY_OFF)&&(key_up_sta==1))
	{
		//ֹ󴥷
		for(i=0; i<0x3FFF; i++)
		{
			if(KEY_UP==KEY_ON)
			{
				return 0;
			}
		}
		key_up_sta=0;
		if(mode==1)
		{
			return 1;
		}
			
		}
		return 0;
}


//жϻص
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	uint32_t i;
	switch(GPIO_Pin)
	{
		/*--------------------------------------------------*/
		case GPIO_PIN_2:	if(KEY_LEFT==KEY_OFF)
											{
													for(i=0;i<0x7FFF;i++)
													{
															if(KEY_LEFT==KEY_ON)
															{
																return;
															}
													}
													LED5_Toggle;
											}
											
											else if(KEY_LEFT==KEY_ON)
											{
													for(i=0;i<0x7FFF;i++)
													{
															if(KEY_LEFT==KEY_OFF)
															{
																return;
															}
													}
													LED5_Toggle;
											}
											break;
											
		/*--------------------------------------------------*/
		case GPIO_PIN_3:	if(KEY_DOWN==KEY_OFF)
											{
													for(i=0;i<0x7FFF;i++)
													{
															if(KEY_DOWN==KEY_ON)
															{
																return;
															}
													}
													LED3_Toggle;
											}
											
											else if(KEY_DOWN==KEY_ON)
											{
													for(i=0;i<0x7FFF;i++)
													{
															if(KEY_DOWN==KEY_OFF)
															{
																return;
															}
													}
													LED3_Toggle;
											}
											break;
											
		/*--------------------------------------------------*/
		case GPIO_PIN_4:	if(KEY_RIGHT==KEY_OFF)
											{
													for(i=0;i<0x7FFF;i++)
													{
															if(KEY_RIGHT==KEY_ON)
															{
																return;
															}
													}
													LED3_Toggle;
											}
											
											else if(KEY_RIGHT==KEY_ON)
											{
													for(i=0;i<0x7FFF;i++)
													{
															if(KEY_RIGHT==KEY_OFF)
															{
																return;
															}
													}
													LED3_Toggle;
											}
											break;								
	}
}


