
#include "stm32f1xx_hal.h"
#include "uart.h"


uint8_t u1_rxbuff[U1_RX_SIZE];
uint8_t u1_txbuff[U1_TX_SIZE];


UCB uart1;


/*-----------UART3(PB10&PB11)ó8N1첽շģʽ----------*/
void UART1_Init(uint32_t baudrate)
{
	//UARTĴĻַ
	uart1.uart.Instance=USART1;	
	//UARTͨŲ
	uart1.uart.Init.BaudRate=baudrate;	
	uart1.uart.Init.WordLength=UART_WORDLENGTH_8B;
	uart1.uart.Init.Parity=UART_PARITY_NONE;
	uart1.uart.Init.StopBits=UART_STOPBITS_1;
	uart1.uart.Init.HwFlowCtl=UART_HWCONTROL_NONE;
	uart1.uart.Init.Mode=UART_MODE_TX_RX;
	
	HAL_UART_Init(&uart1.uart);
	//__HAL_UART_ENABLE_IT(&uart1,UART_IT_RXNE);			//ôڽշǿж(൱жϵһַ),ж HAL_UART_Receive_IT() ᱻ

	U1_PtrInit();
	
}


/*-------------------շָʼ------------------------*/
void U1_PtrInit(void)
{
	uart1.RxCounter = 0;
	uart1.RxInPtr   = &uart1.RxLocation[0];
	uart1.RxOutPtr  = &uart1.RxLocation[0];
	uart1.RxEndPtr  = &uart1.RxLocation[9];
	uart1.RxInPtr->start = u1_rxbuff;
	
	uart1.TxCounter = 0;
	uart1.TxInPtr   = &uart1.TxLocation[0];
	uart1.TxOutPtr  = &uart1.TxLocation[0];
	uart1.TxEndPtr  = &uart1.TxLocation[9];
	uart1.TxInPtr->start = u1_txbuff;
	
	__HAL_UART_ENABLE_IT(&uart1.uart, UART_IT_IDLE);										//ж
	HAL_UART_Receive_IT(&uart1.uart,uart1.RxInPtr->start,U1_RX_MAX);		//ʹܽ
	
}


/*-------------------ڻѽյ------------------------*/
/*: data 		  òָ,ݵʼλ
 *			data_len  ݵĳ
 */
void U1_TxData(uint8_t *data,uint32_t data_len)
{
	//жϷͻʣռ,Сdata_lenͻؾ
	if((U1_TX_SIZE - uart1.TxCounter) >= data_len){
		uart1.TxInPtr->start = &u1_txbuff[uart1.TxCounter];
	}else{
		uart1.TxCounter = 0;
		uart1.TxInPtr->start = u1_txbuff;
	}
	memcpy(uart1.TxInPtr->start,data,data_len);							//
	uart1.TxCounter += data_len;														//¼ѷ͵
	uart1.TxInPtr->end = &u1_txbuff[uart1.TxCounter-1];			//ǷָĽλ
	uart1.TxInPtr++;																				//ָλŲ
	//жϷָλǷԽ
	if(uart1.TxInPtr==uart1.TxEndPtr){
		uart1.TxInPtr   = &uart1.TxLocation[0];
	}
}


/*---------UARTӲصĻص,ʼUARTײӲGPIO,CLK---------*/
void HAL_UART_MspInit(UART_HandleTypeDef *huart)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	
	//huartΪṹָ,ԷڲԱʱҪ"->""."
	if(huart->Instance==USART1){
		//ʱ
		__HAL_RCC_AFIO_CLK_ENABLE();						
		__HAL_RCC_GPIOA_CLK_ENABLE();						//ʹܶ˿ʱ
		__HAL_RCC_USART1_CLK_ENABLE();					//ʹܴʱ
		//__HAL_AFIO_REMAP_USART1_ENABLE();			//GPIOŸùӳ
		
		//(Tx)PB10Ϊģʽ
		GPIO_InitStruct.Pin=GPIO_PIN_9;
		GPIO_InitStruct.Mode=GPIO_MODE_AF_PP;
		GPIO_InitStruct.Speed=GPIO_SPEED_FREQ_MEDIUM;
		HAL_GPIO_Init(GPIOA,&GPIO_InitStruct);
		
		//(Rx)PB11Ϊøģʽ
		GPIO_InitStruct.Pin=GPIO_PIN_10;
		GPIO_InitStruct.Mode=GPIO_MODE_AF_INPUT;
		GPIO_InitStruct.Pull=GPIO_NOPULL;
		HAL_GPIO_Init(GPIOA,&GPIO_InitStruct);
		
		//жϷȼ
		HAL_NVIC_SetPriority(USART1_IRQn ,0,0);
		//ʹж
		HAL_NVIC_EnableIRQ(USART1_IRQn);
		
	}

}


/*------ضc⺯printf,ضʹprintf---------*/
int fputc(int ch, FILE *f)
{
	/*һֽݵ*/
	HAL_UART_Transmit(&uart1.uart,(uint8_t *)&ch,1,1000);
	return (ch);
}


/*----ضc⺯scanf,ضʹscanf,getcharȺ---*/
int fgetc(FILE *f)
{
	int ch;
	HAL_UART_Receive(&uart1.uart,(uint8_t *)&ch,1,1000);
	return (ch);
}


/*----------------------ַ-------------------------------*/
void Uart_SendString(uint8_t *str)
{
	unsigned int k=0;
	do
	{
		HAL_UART_Transmit(&uart1.uart,(uint8_t *)(str+k),1,1000);
		k++;
	}while(*(str+k)!='\0');
}


/*------------------ɻصǿ------------------------*/
void HAL_UART_RxCpltCallback(UART_HandleTypeDef *huart)
{
	//жһڷж
	if(huart->Instance==USART1){
		
	}

}


/*-------------------صǿ------------------------------*/
void HAL_UART_ErrorCallback(UART_HandleTypeDef *huart)
{
	//жһڷж
	if(huart->Instance==USART1){
		
	}
}


/*-------------------ɻصǿ-------------------------*/
void HAL_UART_TxCpltCallback(UART_HandleTypeDef *huart)
{
	//жһڷж
	if(huart->Instance==USART1){
		uart1.TxState=0;
	}

}


/*-------------------ֹջصǿ-------------------------*/
void HAL_UART_AbortReceiveCpltCallback(UART_HandleTypeDef *huart)
{
	//жһڷж
	if(huart->Instance==USART1){
		uart1.RxInPtr->end = &u1_rxbuff[uart1.RxCounter-1];			//¼ָĽλ
		uart1.RxInPtr++;																				//ָŲһλ
		//жϽָλǷԽ
		if(uart1.RxInPtr==uart1.RxEndPtr){
			uart1.RxInPtr = &uart1.RxLocation[0];
		}
		//жϽջĿλ,С U1_RX_MAX Ҫؾջ׵ַ
		if((U1_RX_SIZE-uart1.RxCounter) < U1_RX_MAX){
			uart1.RxCounter = 0;
			uart1.RxInPtr->start = u1_rxbuff;
		}else{
			uart1.RxInPtr->start = &u1_rxbuff[uart1.RxCounter];
		}
		HAL_UART_Receive_IT(&uart1.uart,uart1.RxInPtr->start,U1_RX_MAX);		//ʹܽ
	}	
}

